/* $Id: samp1.cpp,v 1.2 1995/09/23 21:23:33 artc Exp $ */
//  samp1.cpp
// This program demonstrates iterating over a symbol table...specifically
// the linetype table.


#include <stdlib.h>
#include <rxobject.h>
#include <rxregsvc.h>
#include <aced.h>
#include <dbsymtb.h>
#include <adslib.h>

// function prototypes

void iterate_linetypes();
void initApp();
void unloadApp();
extern "C" AcRx::AppRetCode acrxEntryPoint(AcRx::AppMsgCode, void*);


// Opens the linetype table and iterates through all the entries
// printing the name of each linetype.
//
void
iterate_linetypes()
{
    AcDbLinetypeTable *pLinetypeTbl;

   	// get the linetypeTable
   	//...
   
   	// create a new iterator that starts at table beginning and skips deleted
   	//...

    // walk the table getting every table record and printing the
    // linetype name.  This will require that you set up a loop that:
    //  1) gets the AcDbLinetypeTableRecord
    //  2) gets the linetype name from the record (you will have to allocate
    //     memory for this string.  You can do so dynamically or statically.
    //     if you do so dynamically,  don't forget to free the memory when
    //     you're done.
    //  3) prints the name
    //  Don't forget to close the record when you're done accessing it
    //  (this would be a good place to use the transaction manager)
    //...

	// delete the iterator
	//...

	// close the linetype table
	//...
}


// Initialization function called from acrxEntryPoint during kInitAppMsg
// case.  This function is used to add commands to the command stack.
//
void
initApp()
{
    acedRegCmds->addCommand("TABLETEST_COMMANDS", "ITERATE", "ITERATE",
        ACRX_CMD_MODAL, &iterate_linetypes);
}


// Clean up function called from acrxEntryPoint during the kUnloadAppMsg
// case.  This function removes this apps command set from the command
// stack.
//
void
unloadApp()
{
    acedRegCmds->removeGroup("TABLETEST_COMMANDS");
}


// ARX entry point
//
AcRx::AppRetCode
acrxEntryPoint(AcRx::AppMsgCode msg, void* pkt)
{
    switch(msg) {
    case AcRx::kInitAppMsg:
	    acrxDynamicLinker->unlockApplication(pkt);
        initApp();
        break;
    case AcRx::kUnloadAppMsg:
        unloadApp();
        break;
    case AcRx::kLoadADSMsg:
    case AcRx::kUnloadADSMsg:
    default:
        break;
    }
    return AcRx::kRetOK;
}
