/* $Id: rxhello3.cpp,v 1.1 1994/10/18 16:27:04 edwardb Exp $ */
/* 
      (C) Copyright 1993-1994 by Autodesk, Inc.

******************************************************************************
*                                                                            *
* The information contained herein is confidential, proprietary to Autodesk, *
* Inc., and considered a trade secret as defined in section 499C of the      *
* penal code of the State of California.  Use of this information by anyone  *
* other than authorized employees of Autodesk, Inc. is granted only under a  *
* written non-disclosure agreement, expressly prescribing the scope and      *
* manner of such use.                                                        *
*                                                                            *
******************************************************************************/

/*
	rxhello3.cpp

	The minimal Rx program defining and exporting a C function.
	It says 'hello' both at initModule and syncModule.
	It defines a function HelloFunc which appropriately enough also
	says hello. Two additional functions show that arguments can be
	accepted and complex return values passed back.

	The client application defines an AutoCAD command HELLO3
	which invokes HelloFunc through the Rx mechanisms.

	Jeremy Tammik, Autodesk ESC, 93-11-19
*/
#include <rxdefs.h>
#include <rxregsvc.h> // register services
#include <adslib.h>
#include "hello3.h" // RX_SERVICE

void initModule()
{
	ads_printf ("Rx Hello 3 Server -- initModule\n");
	acrxRegisterService (RX_SERVICE);
}

extern "C" AcRx::AppRetCode acrxEntryPoint (AcRx::AppMsgCode msg, void*)
{
	switch(msg) {
	case AcRx::kInitAppMsg:
		initModule ();
		break;
	case AcRx::kUnloadAppMsg:
		ads_printf ("Rx Hello 3 -- kUnloadAppMsg\n");
		break;
	case AcRx::kLoadADSMsg:
		ads_printf ("Rx Hello 3 -- kLoadADSMsg\n");
		break;
	case AcRx::kUnloadADSMsg:
		ads_printf ("Rx Hello 3 -- kUnloadADSMsg\n");
		break;
	default:
		ads_printf ("Rx Hello 3 -- <unknown message %d>\n", msg);
		break;
	}
	return AcRx::kRetOK;
}

