/* $Id: grouptst.cpp,v 1.2 1995/08/16 17:23:54 elevy Exp $ */
/* 
      (C) Copyright 1993-1995 by Autodesk, Inc.

******************************************************************************
*                                                                            *
* The information contained herein is confidential, proprietary to Autodesk, *
* Inc., and considered a trade secret as defined in section 499C of the      *
* penal code of the State of California.  Use of this information by anyone  *
* other than authorized employees of Autodesk, Inc. is granted only under a  *
* written non-disclosure agreement, expressly prescribing the scope and      *
* manner of such use.                                                        *
*                                                                            *
******************************************************************************/

/*
	(C) Copyright 1982-1992,1994,1995 by Autodesk, Inc.

******************************************************************************
* The information contained herein is confidential, proprietary to Autodesk, *
* Inc., and considered a trade secret as defined in section 499C of the      *
* penal code of the State of California.  Use of this information by anyone  *
* other than authorized employees of Autodesk, Inc. is granted only under a  *
* written non-disclosure agreement, expressly prescribing the scope and      *
* manner of such use.                                                        *
******************************************************************************/
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <ctype.h>

#include "rxobject.h"
#include "rxregsvc.h"
#include "rxdlinkr.h"
#include "rxditer.h"
#include "rxascii.h"
#include "aced.h"
#include "adslib.h"
#include "math.h"
#include "dbents.h"
#include "dbdict.h"
#include "dbsymtb.h"
#include "dbgroup.h"

// Group test functions;
//
void createGroup();
void appendToGroup();
void prependToGroup();
void insertIntoGroup();
void removeFromGroup();
void replaceInGroup();
void reverseGroup();
void listGroup();
void clearGroup();
void setDescription();
void getDescription();
void setSelectable();
void getSelectable();
void setDisplay();
void nbrEntities();
void getIndex();
void removeGroup();
void removeAllGroups();
void showGroups();
void multIterGroup();
void setGroupColor();
void setGroupLayer();
void setGroupLinetype();
void setGroupLinetypeScale();
void setGroupVisibility();
void setGroupHighlight();


/* =================== Rx Module Interface Functions ================ */

// Initialization Function
//
void initModule()
{

	// Register commands.
	//
	acedRegCmds->addCommand("HELLO10", "CREATEGROUP", "CREATEGROUP",
				ACRX_CMD_MODAL, &createGroup);

	acedRegCmds->addCommand("HELLO10", "APPENDTOGROUP", "APPENDTOGROUP",
				ACRX_CMD_MODAL, &appendToGroup);

	acedRegCmds->addCommand("HELLO10", "SETGROUPDESC", "SETGROUPDESC",
				ACRX_CMD_MODAL, &setDescription);

	acedRegCmds->addCommand("HELLO10", "GETGROUPDESC", "GETGROUPDESC",
				ACRX_CMD_MODAL, &getDescription);

	acedRegCmds->addCommand("HELLO10", "SETGROUPSELECTABLE",
							"SETGROUPSELECTABLE",
				ACRX_CMD_MODAL, &setSelectable);

	acedRegCmds->addCommand("HELLO10", "GETGROUPSELECTABLE",
							"GETGROUPSELECTABLE",
				ACRX_CMD_MODAL, &getSelectable);

	acedRegCmds->addCommand("HELLO10", "SETGROUPDISPLAY",
							"SETGROUPDISPLAY",
				ACRX_CMD_MODAL, &getSelectable);

	acedRegCmds->addCommand("HELLO10", "NBRGROUPENTITIES",
							"NBRGROUPENTITIES",
				ACRX_CMD_MODAL, &nbrEntities);

	acedRegCmds->addCommand("HELLO10", "GROUPENTINDEX", "GROUPENTINDEX",
				ACRX_CMD_MODAL, &getIndex);

	acedRegCmds->addCommand("HELLO10", "PREPENDTOGROUP", "PREPENDTOGROUP",
				ACRX_CMD_MODAL, &prependToGroup);

	acedRegCmds->addCommand("HELLO10", "INSERTINTOGROUP", "INSERTINTOGROUP",
				ACRX_CMD_MODAL, &insertIntoGroup);

	acedRegCmds->addCommand("HELLO10", "REMOVEFROMGROUP", "REMOVEFROMGROUP",
				ACRX_CMD_MODAL, &removeFromGroup);

	acedRegCmds->addCommand("HELLO10", "REPLACEINGROUP", "REPLACEINGROUP",
				ACRX_CMD_MODAL, &replaceInGroup);

	acedRegCmds->addCommand("HELLO10", "CLEARGROUP", "CLEARGROUP",
				ACRX_CMD_MODAL, &clearGroup);

	acedRegCmds->addCommand("HELLO10", "REVERSEGROUP", "REVERSEGROUP",
				ACRX_CMD_MODAL, &reverseGroup);

	acedRegCmds->addCommand("HELLO10", "LISTGROUP", "LISTGROUP",
				ACRX_CMD_MODAL, &listGroup);

	acedRegCmds->addCommand("HELLO10", "REMOVEGROUP", "REMOVEGROUP",
				ACRX_CMD_MODAL, &removeGroup);

	acedRegCmds->addCommand("HELLO10", "REMOVEALLGROUPS", "REMOVEALLGROUPS",
				ACRX_CMD_MODAL, &removeAllGroups);

	acedRegCmds->addCommand("HELLO10", "SHOWGROUPS", "SHOWGROUPS",
				ACRX_CMD_MODAL, &showGroups);

	acedRegCmds->addCommand("HELLO10", "MULTITERGROUP", "MULTITERGROUP",
				ACRX_CMD_MODAL, &multIterGroup);

	acedRegCmds->addCommand("HELLO10", "SETGROUPCOLOR", "SETGROUPCOLOR",
				ACRX_CMD_MODAL, &setGroupColor);

	acedRegCmds->addCommand("HELLO10", "SETGROUPLAYER", "SETGROUPLAYER",
				ACRX_CMD_MODAL, &setGroupLayer);

	acedRegCmds->addCommand("HELLO10", "SETGROUPLINETYPE", "SETGROUPLINETYPE",
				ACRX_CMD_MODAL, &setGroupLinetype);

	acedRegCmds->addCommand("HELLO10", "SETGROUPLTYPESCALE", "SETGROUPLTYPESCALE",
				ACRX_CMD_MODAL, &setGroupLinetypeScale);

	acedRegCmds->addCommand("HELLO10", "SETGROUPVIS", "SETGROUPVIS",
				ACRX_CMD_MODAL, &setGroupVisibility);

	acedRegCmds->addCommand("HELLO10", "SETGROUPHIGHLIGHT", "SETGROUPHIGHLIGHT",
				ACRX_CMD_MODAL, &setGroupHighlight);
}

//
// ------- Functions to test AcDbGroup API.
//

// Creates an empty group.
//
void createGroup()
{
	// Construct a group.
	//
	char gName[133], gDesc[133];
	ads_getstring( Adesk::kFalse, "Enter Group Name:", gName );
	ads_getstring( Adesk::kTrue, "Enter Group Description:", gDesc);

	AcDbGroup* grp1 = new AcDbGroup(gName, gDesc, Adesk::kTrue);

	// Now add the group to the group dictionary.
	//
	AcDbDictionary* pGrpDict;
	Acad::ErrorStatus status = acdbCurDwg()->groupTable( pGrpDict,
		AcDb::kForWrite );

	if ( status == Acad::eOk ) {
		AcDbObjectId dummyId;
		status = pGrpDict->setAt(gName, (AcDbObject*)grp1, dummyId );
		if (status != Acad::eOk)
			ads_printf("\nError updating dictionary, stat = %d\n", status);
		pGrpDict->close();
	}
	else {
		ads_printf("\nError opening the dictionary, stat = %d\n", status);
	}

	// Close the group.
	//
	grp1->close();
}


// Appends the entities in a selection set to a group.
//
void appendToGroup()
{
	// Get group from user.
	//
	char gName[133];
	ads_getstring( Adesk::kFalse, "Enter Group Name:", gName );

	// Get selection set from user.
	//
	ads_name ssname;
	ads_ssget(NULL, NULL, NULL, NULL, ssname);
	long ssLen = 0;
	ads_sslength(ssname, &ssLen);

	// Append each entity to the group.
	//
	AcDbDictionary* pGrpDict;
	Acad::ErrorStatus status = acdbCurDwg()->groupTable( pGrpDict,
		AcDb::kForRead );

	if (status == Acad::eOk) {
		AcDbGroup* pGrp;

		status = pGrpDict->getAt(gName, AcDb::kForWrite, 
			*((AcDbObject**)&pGrp) );
		if (status == Acad::eOk) {
			ads_name entName;
			AcDbObjectId entId;

			for (int i = 0; i < ssLen; i++) {
				ads_ssname(ssname, i, entName);

				// Convert entity name to AcDbObjectId.
				//
				status = acdbGetObjectId(entId, entName);
				if (status != Acad::eOk) {
					ads_printf("\nError getting object id, stat = %d\n", status);
					break;
				}

				status = pGrp->append(entId);

				if (status != Acad::eOk)
					ads_printf("\nError appending entity, stat = %d\n", status);
			}

			// Close the group.
			//
			pGrp->close();
		}
		else
			ads_printf("\nUnable to open %s, stat = %d\n", gName, status);

			// Close the group symbol table (dictionary).
			//
		pGrpDict->close();
	}
	else
		ads_printf("\nUnable to open group dictionary, stat = %d\n", status);

	ads_ssfree(ssname);
}


// Prepends the entities in a selection set to a group.
//
void prependToGroup()
{
	// Get group from user.
	//
	char gName[133];
	ads_getstring( Adesk::kFalse, "Enter Group Name:", gName );

	// Get selection set from user.
	//
	ads_name ssname;
	ads_ssget(NULL, NULL, NULL, NULL, ssname);
	long ssLen = 0;
	ads_sslength(ssname, &ssLen);

	// Prepend each entity to the group.
	//
	AcDbDictionary* pGrpDict;
	Acad::ErrorStatus status = acdbCurDwg()->groupTable( pGrpDict,
		AcDb::kForRead );

	if (status == Acad::eOk) {
		AcDbGroup* pGrp;

		status = pGrpDict->getAt(gName, AcDb::kForWrite, *((AcDbObject**)&pGrp) );
		if (status == Acad::eOk) {
		ads_name entName;
		AcDbObjectId entId;

		for (int i = 0; i < ssLen; i++) {
			ads_ssname(ssname, i, entName);

			// Convert entity name to AcDbObjectId.
		//
			status = acdbGetObjectId(entId, entName);
			if (status != Acad::eOk) {
			ads_printf("\nError getting object id, stat = %d\n", status);
				break;
			}

			status = pGrp->prepend(entId);

		if (status != Acad::eOk)
  		ads_printf("\nError prepending entity, stat = %d\n", status);
	}

	pGrp->close();
		}
		else
	ads_printf("\nUnable to open %s, stat = %d\n", gName, status);

		pGrpDict->close();
	}
	else
		ads_printf("\nUnable to open group dictionary, stat = %d\n", status);

	ads_ssfree(ssname);
}


// Inserts the entities in a selection set into a group, before or after
// the specified index position.  Indices begin at zero.
//
void insertIntoGroup()
{
	// Get group from user.
	//
	char gName[133];
	ads_getstring( Adesk::kFalse, "Enter Group Name:", gName );

	// Get selection set from user.
	//
	ads_name ssname;
	ads_ssget(NULL, NULL, NULL, NULL, ssname);
	long ssLen = 0;
	ads_sslength(ssname, &ssLen);

	// Determine insertion point.
	//
	int index = -1;
	while (index < 0)
		ads_getint("Enter positive insertion index: ", &index);

	// Determine how to insert.
	//
	char insertMode[133];
	ads_getstring(Adesk::kFalse, "Insert before or after [B/A]: ", insertMode);
	Adesk::Boolean after = (insertMode[0] == 'A' || insertMode[0] == 'a');

	// Insert each entity into the group.
	//
	AcDbDictionary* pGrpDict;
	Acad::ErrorStatus status = acdbCurDwg()->groupTable( pGrpDict,
							AcDb::kForRead );

	if (status == Acad::eOk) {
		AcDbGroup* pGrp;

		status = pGrpDict->getAt(gName, AcDb::kForWrite, *((AcDbObject**)&pGrp) );
		if (status == Acad::eOk) {
		ads_name entName;
		AcDbObjectId entId;

		for (int i = 0; i < ssLen; i++) {
			ads_ssname(ssname, i, entName);

			// Convert entity name to AcDbObjectId.
		//
			status = acdbGetObjectId(entId, entName);
			if (status != Acad::eOk) {
			ads_printf("\nError getting object id, stat = %d\n", status);
				break;
			}

			status = pGrp->insertAt(index+i, entId);

		if (status != Acad::eOk)
  		ads_printf("\nError inserting entity, stat = %d\n", status);
	}

	pGrp->close();
		}
		else
	ads_printf("\nUnable to open %s, stat = %d\n", gName, status);

		pGrpDict->close();
	}
	else
		ads_printf("\nUnable to open group dictionary, stat = %d\n", status);

	ads_ssfree(ssname);
}


// Removes the entities in a selection set from a group.
//
void removeFromGroup()
{
	// Get group from user.
	char gName[133];
	ads_getstring( Adesk::kFalse, "Enter Group Name:", gName );

	// Get selection set from user.
	//
	ads_name ssname;
	ads_ssget(NULL, NULL, NULL, NULL, ssname);
	long ssLen = 0;
	ads_sslength(ssname, &ssLen);

	// Remove each entity from the group.
	//
	AcDbDictionary* pGrpDict;
	Acad::ErrorStatus status = acdbCurDwg()->groupTable( pGrpDict,
								AcDb::kForRead );

	if (status == Acad::eOk) {
		AcDbGroup* pGrp;

		status = pGrpDict->getAt(gName, AcDb::kForWrite, *((AcDbObject**)&pGrp) );
		if (status == Acad::eOk) {
		ads_name entName;
		AcDbObjectId entId;

		for (int i = 0; i < ssLen; i++) {
			ads_ssname(ssname, i, entName);

			// Convert entity name to AcDbObjectId.
		//
			status = acdbGetObjectId(entId, entName);
			if (status != Acad::eOk) {
			ads_printf("\nError getting object id, stat = %d\n", status);
				break;
			}

			status = pGrp->remove(entId);

		if (status != Acad::eOk)
  			ads_printf("\nError removing entity, stat = %d\n", status);
	}

		// Close the group.
		//
	pGrp->close();
		}
		else
	ads_printf("\nUnable to open %s, stat = %d\n", gName, status);

		// Close the group dictionary.
		//
		pGrpDict->close();
	}
	else
		ads_printf("\nUnable to open group dictionary, stat = %d\n", status);

	ads_ssfree(ssname);
}


// Replaces an entity in a group with the entities in a selection set.
//
void replaceInGroup()
{
	// Get group from user.
	//
	char gName[133];
	ads_getstring( Adesk::kFalse, "Enter Group Name:", gName );

	// Get entity to be replaced.
	//
	ads_name replaceEnt;
	ads_point dummy;
	ads_entsel("Pick object to replace: ", replaceEnt, dummy);

	// Get replacements.
	//
	ads_name ssname;
	ads_ssget(NULL, NULL, NULL, NULL, ssname);
	long ssLen = 0;
	ads_sslength(ssname, &ssLen);

	// Insert each entity into the group.
	//
	AcDbDictionary* pGrpDict;
	Acad::ErrorStatus status = acdbCurDwg()->groupTable( pGrpDict,
								AcDb::kForRead );

	if (status == Acad::eOk) {
		AcDbGroup* pGrp;

		status = pGrpDict->getAt(gName, AcDb::kForWrite, *((AcDbObject**)&pGrp) );
		if (status == Acad::eOk) {

	// Get the replaceEnt's object id.
	//
	AcDbObjectId replaceId;
		status = acdbGetObjectId(replaceId, replaceEnt);
		if (status != Acad::eOk) {
			ads_printf("\nError getting object id, stat = %d\n", status);
		}
	else
	{
		// Get index of replaceId, then remove replaceId.
		//
		Adesk::UInt32 idx;
		status = pGrp->getIndex( replaceId, idx );

		if (status == Acad::eOk) {

		status = pGrp->remove( replaceId );

		if (status == Acad::eOk) {

			// Now insert the replacements before the index position.
			//
			ads_name entName;
			AcDbObjectId entId;

			for (int i = 0; i < ssLen; i++) {
		ads_ssname(ssname, i, entName);

		// Convert entity name to AcDbObjectId.
		//
		status = acdbGetObjectId(entId, entName);
		if (status != Acad::eOk) {
			ads_printf("\nError getting object id, stat = %d\n", status);
			break;
		}

		status = pGrp->insertAt(idx+i, entId);

		if (status != Acad::eOk)
			ads_printf("\nError inserting entity, stat = %d\n", status);
			}
		}
		else
			ads_printf("\nUnable to remove entity from group\n");
		}
		else
		ads_printf("\nUnable to get entity index, stat = %d\n", status);
		}

		pGrp->close();
		}
		else
	ads_printf("\nUnable to open %s, stat = %d\n", gName, status);

		pGrpDict->close();
	}
	else
		ads_printf("\nUnable to open group dictionary, stat = %d\n", status);

	ads_ssfree(ssname);
}


// Clears a group of its entities.
//
void clearGroup()
{
  char gName[133];
  ads_getstring( Adesk::kFalse, "Enter Group Name:", gName );

  AcDbDictionary* pGrpDict;
  Acad::ErrorStatus status = acdbCurDwg()->groupTable( pGrpDict,
								AcDb::kForRead );

  if ( status == Acad::eOk ) {
	AcDbGroup* pGrp;
	status = pGrpDict->getAt(gName, AcDb::kForWrite, *((AcDbObject**)&pGrp) );
	if (status == Acad::eOk) {
		status = pGrp->clear();
		if (status != Acad::eOk)
	ads_printf("\nUnable to clear group, stat = %d\n", status);
		pGrp->close();
	}
	else
		ads_printf("\nUnable to get %s, stat = %d\n", gName, status);

	pGrpDict->close();
  }
  else
	ads_printf("\nUnable to open group dictionary, stat = %d\n", status);
}


// Reverses the order of a group.
//
void reverseGroup()
{
  char gName[133];
  ads_getstring( Adesk::kFalse, "Enter Group Name:", gName );

  AcDbDictionary* pGrpDict;
  Acad::ErrorStatus status = acdbCurDwg()->groupTable( pGrpDict,
								AcDb::kForRead );

  if ( status == Acad::eOk ) {
	AcDbGroup* pGrp;
	status = pGrpDict->getAt(gName, AcDb::kForWrite, *((AcDbObject**)&pGrp) );
	if (status == Acad::eOk) {
		status = pGrp->reverse();
		if (status != Acad::eOk)
	ads_printf("\nUnable to reverse group, stat = %d\n", status);
		pGrp->close();
	}
	else
		ads_printf("\nUnable to get %s, stat = %d\n", gName, status);

	pGrpDict->close();
  }
  else
	ads_printf("\nUnable to open group dictionary, stat = %d\n", status);
}


// Prints the object id's of the entities in a group.
//
void listGroup()
{
  char gName[133];
  ads_getstring( Adesk::kFalse, "Enter Group Name:", gName );

  AcDbDictionary* pGrpDict;
  Acad::ErrorStatus status = acdbCurDwg()->groupTable( pGrpDict,
								AcDb::kForRead );

  if ( status == Acad::eOk ) {
	AcDbGroup* pGrp;
	status = pGrpDict->getAt(gName, AcDb::kForRead, *((AcDbObject**)&pGrp) );
	if (status == Acad::eOk) {
		ads_printf("\nEntities in %s:\n\n", gName);
		AcDbGroupIterator* i = pGrp->newIterator();
		while( i->notDone() ) {
	i->nextElement();
		AcDbObjectId id = i->objectId();
		ads_printf("%d\n", id.asOldId() );
		}
		delete i;
		pGrp->close();
	}
	else
		ads_printf("\nUnable to get %s, stat = %d\n", gName, status);

	pGrpDict->close();
  }
  else
	ads_printf("\nUnable to open group dictionary, stat = %d\n", status);
}


// Sets the description of a group.
//
void setDescription()
{
  char gName[133];
  ads_getstring( Adesk::kFalse, "Enter Group Name:", gName );

  char description[133];
  ads_getstring( Adesk::kTrue, "Enter new description:", description );

  AcDbDictionary* pGrpDict;
  Acad::ErrorStatus status = acdbCurDwg()->groupTable( pGrpDict,
								AcDb::kForRead );

  if ( status == Acad::eOk ) {
	AcDbGroup* pGrp;
	status = pGrpDict->getAt(gName, AcDb::kForWrite, *((AcDbObject**)&pGrp) );
	if (status == Acad::eOk) {
		pGrp->setDescription( description );
		pGrp->close();
	}
	else
		ads_printf("\nUnable to get %s, stat = %d\n", gName, status);

	pGrpDict->close();
  }
  else
	ads_printf("\nUnable to open group dictionary, stat = %d\n", status);
}


// Prints out the description of a group.
//
void getDescription()
{
  char gName[133];
  ads_getstring( Adesk::kFalse, "Enter Group Name:", gName );

  AcDbDictionary* pGrpDict;
  Acad::ErrorStatus status = acdbCurDwg()->groupTable( pGrpDict,
								AcDb::kForRead );

  if ( status == Acad::eOk ) {
	AcDbGroup* pGrp;
	status = pGrpDict->getAt(gName, AcDb::kForRead, *((AcDbObject**)&pGrp) );
	if (status == Acad::eOk) {
		ads_printf("\nDescription: %s\n", pGrp->description() );
		pGrp->close();
	}
	else
		ads_printf("\nUnable to get %s, stat = %d\n", gName, status);

	pGrpDict->close();
  }
  else
	ads_printf("\nUnable to open group dictionary, stat = %d\n", status);
}


// Sets whether a group is selectable as a whole.
//
void setSelectable()
{
  char gName[133];
  ads_getstring( Adesk::kFalse, "Enter Group Name:", gName );

  // Determine how to insert.
  //
  char sel_str[133];
  ads_getstring(Adesk::kFalse, "Set selectability of group [T/F]: ", sel_str);
  Adesk::Boolean sel = (sel_str[0] == 'T' || sel_str[0] == 't');

  AcDbDictionary* pGrpDict;
  Acad::ErrorStatus status = acdbCurDwg()->groupTable( pGrpDict,
								AcDb::kForRead );

  if ( status == Acad::eOk ) {
	AcDbGroup* pGrp;
	status = pGrpDict->getAt(gName, AcDb::kForWrite, *((AcDbObject**)&pGrp) );
	if (status == Acad::eOk) {
		pGrp->setSelectable( sel );
		pGrp->close();
	}
	else
		ads_printf("\nUnable to get %s, stat = %d\n", gName, status);

	pGrpDict->close();
  }
  else
	ads_printf("\nUnable to open group dictionary, stat = %d\n", status);
}


// Prints out whether a group is selectable as a whole.
//
void getSelectable()
{
  char gName[133];
  ads_getstring( Adesk::kFalse, "Enter Group Name:", gName );

  AcDbDictionary* pGrpDict;
  Acad::ErrorStatus status = acdbCurDwg()->groupTable( pGrpDict,
								AcDb::kForRead );

  if ( status == Acad::eOk ) {
	AcDbGroup* pGrp;
	status = pGrpDict->getAt(gName, AcDb::kForRead, *((AcDbObject**)&pGrp) );
	if (status == Acad::eOk) {
		ads_printf("\nSelectable: %d\n", pGrp->isSelectable() );
		pGrp->close();
	}
	else
		ads_printf("\nUnable to get %s, stat = %d\n", gName, status);

	pGrpDict->close();
  }
  else
	ads_printf("\nUnable to open group dictionary, stat = %d\n", status);
}

void setDisplay()
{
}


// Prints out the number of entities in a group.
//
void nbrEntities()
{
  char gName[133];
  ads_getstring( Adesk::kFalse, "Enter Group Name:", gName );

  AcDbDictionary* pGrpDict;
  Acad::ErrorStatus status = acdbCurDwg()->groupTable( pGrpDict,
								AcDb::kForRead );

  if ( status == Acad::eOk ) {
	AcDbGroup* pGrp;
	status = pGrpDict->getAt(gName, AcDb::kForRead, *((AcDbObject**)&pGrp) );
	if (status == Acad::eOk) {
		ads_printf("\nNumber of entities: %d\n", pGrp->numEntities() );
		pGrp->close();
	}
	else
		ads_printf("\nUnable to get %s, stat = %d\n", gName, status);

	pGrpDict->close();
  }
  else
	ads_printf("\nUnable to open group dictionary, stat = %d\n", status);
}


// Gets the index position of an entity in a group.
//
void getIndex()
{
	// Get group from user.
	char gName[133];
	ads_getstring( Adesk::kFalse, "Enter Group Name:", gName );

	// Get entity.
	//
	ads_name indexEnt;
	ads_point dummy;
	ads_entsel("Pick object for index: ", indexEnt, dummy);

  AcDbDictionary* pGrpDict;
  Acad::ErrorStatus status = acdbCurDwg()->groupTable( pGrpDict,
								AcDb::kForRead );

  if ( status == Acad::eOk ) {
	AcDbGroup* pGrp;
	status = pGrpDict->getAt(gName, AcDb::kForRead, *((AcDbObject**)&pGrp) );
	if (status == Acad::eOk) {
		AcDbObjectId entId;
		status = acdbGetObjectId(entId, indexEnt);

		if (status != Acad::eOk) {
		ads_printf("\nError getting object id, stat = %d\n", status);
		}
		else {
		Adesk::UInt32 idx;
	status = pGrp->getIndex( entId, idx );

		if (status == Acad::eOk)
			ads_printf("\nIndex: %d:\n\n", idx );
		else
		ads_printf("\nUnable to get entity index, stat = %d\n", status);
		}

		pGrp->close();
	}
	else
		ads_printf("\nUnable to get %s, stat = %d\n", gName, status);

	pGrpDict->close();
  }
  else
	ads_printf("\nUnable to open group dictionary, stat = %d\n", status);
}


// Removes a group from the group dictionary.
//
void removeGroup()
{
AcDbDictionary* pGrpDict;

	// Get group from user.
	char gName[133];
	ads_getstring( Adesk::kFalse, "Enter Group Name To Remove:", gName );

	// Open group dictionary for write.
	//
	Acad::ErrorStatus status = acdbCurDwg()->groupTable( pGrpDict,
							AcDb::kForWrite );

	// Remove all the entities from the group.
	//
	if ( status == Acad::eOk ) {
		AcDbGroup* pGrp;
		status = pGrpDict->getAt(gName, AcDb::kForWrite,
									*((AcDbObject**)&pGrp) );
		if (status == Acad::eOk) {
			status = pGrp->clear();
			if (status != Acad::eOk)
			ads_printf("\nUnable to clear group, stat = %d\n", status);
			pGrp->close();
		}
		else
			ads_printf("\nUnable to get %s, stat = %d\n", gName, status);

	}
	else
		ads_printf("\nUnable to open group dictionary, stat = %d\n", status);

	// Remove the group from the dictionary.
	//
	status = pGrpDict->remove(gName);

	// Close the dictionary.
	//
	pGrpDict->close();

}


// Removes all the groups from the group dictionary.  By the way,
// this is generally a bad thing to do--you might be removing another
// application's groups.  Applications must uniquely prefix their groups
// to determine which groups to actually remove.
//
void removeAllGroups()
{
AcDbDictionary* pGrpDict;

	// Open group dictionary for write.
	//
	Acad::ErrorStatus status = acdbCurDwg()->groupTable( pGrpDict,
							AcDb::kForWrite );

	// Iterate through all groups.
	//
	AcDbDictionaryIterator* pIter;
	AcDbGroup* pGrp;
	AcDbObject* tObj;
	pIter = pGrpDict->newIterator();
	while (!pIter->done()) {
		status = pIter->object(AcDb::kForWrite, tObj);
		if (status == Acad::eOk) {
			char* pGrpName;
			pGrpName = pIter->name();
			pGrp = AcDbGroup::cast(tObj);
			status = pGrp->clear();
			if (status != Acad::eOk)
				ads_printf("\nUnable to clear group, stat = %d\n", status);

			tObj->close();
			status = pGrpDict->remove(pGrpName);
			if (status != Acad::eOk) {
				ads_printf("\nUnable to remove group from dictionary.\n");
			}
		}
		else {
			ads_printf("Error retrieving group from dictionary.\n");
		}
		delete pIter;
		pIter = pGrpDict->newIterator();
	}

	// Close the dictionary.
	//
	pGrpDict->close();

}


// Prints out information regarding a group.
//
void showGroups()
{
AcDbDictionary* pGrpDict;

	// Open group dictionary for read.
	//
	Acad::ErrorStatus status = acdbCurDwg()->groupTable( pGrpDict,
							AcDb::kForRead );

	// Iterate through all groups.
	//
	AcDbDictionaryIterator* pIter;
	AcDbGroup* pGrp;
	AcDbObject* tObj;
	for (pIter = pGrpDict->newIterator(); !pIter->done();
				pIter->nextElement()) {
		status = pIter->object(AcDb::kForRead, tObj);
		if (status == Acad::eOk) {
			pGrp = AcDbGroup::cast(tObj);
			int iNumEnts = pGrp->numEntities();
			char* gName;
			const char* gDesc;
			gName = pIter->name();
			gDesc = pGrp->description();
			ads_printf("Name: %s\n", gName);
			ads_printf("Description: %s\n", gDesc);
			ads_printf("Number of Entities: %d\n\n", iNumEnts);

			pGrp->close();
		}
		else {
			ads_printf("Error retrieving entity from group.\n");
		}
	}
	// Delete the iterator.
	//
	delete pIter;

	// Close the dictionary.
	//
	pGrpDict->close();
}


// Tests multiple iterators on a single group.  Each object id for
// each entity in the group is printed out twice.
//
void multIterGroup()
{
	char gName[133];
	ads_getstring( Adesk::kFalse, "Enter Group Name:", gName );

	AcDbDictionary* pGrpDict;
	Acad::ErrorStatus status = acdbCurDwg()->groupTable( pGrpDict,
								AcDb::kForRead );

	if (status == Acad::eOk) {
		AcDbGroup* pGrp;

		status = pGrpDict->getAt(gName, AcDb::kForWrite, *((AcDbObject**)&pGrp) );
		if (status == Acad::eOk) {

		ads_printf("\nDoubled Entities in %s:\n\n", gName);
		AcDbGroupIterator* i1 = pGrp->newIterator();
	AcDbGroupIterator* i2 = pGrp->newIterator();

	// Start the first iterator before loop.
	//
	AcDbObjectId id;
	if (i1->notDone()) {
  		i1->nextElement();
		id = i1->objectId();
		ads_printf("%d\n", id.asOldId() );
	}

	// Iterate both iterators until the first iterator is done.
	//
		while( i1->notDone() ) {
 		i2->nextElement();
		i1->nextElement();

			id = i2->objectId();
			ads_printf("%d\n", id.asOldId() );

		id = i1->objectId();
		ads_printf("%d\n", id.asOldId() );
	}

	// Second iterator is one behind, so let it catch up.
	//
	if (i2->notDone()) {
  		i2->nextElement();
		AcDbObjectId id = i2->objectId();
		ads_printf("%d\n", id.asOldId() );
	}

		delete i1;
		delete i2;
		pGrp->close();
		}
		else
		ads_printf("\nUnable to get %s, stat = %d\n", gName, status);

		pGrpDict->close();
	}
	else
		ads_printf("\nUnable to open group dictionary, stat = %d\n", status);
}


// Set the color for each entity in the group.
//
void setGroupColor()
{
	AcDbDictionary* pGrpDict;
	int iIndex = -1;

	// Get group from user.
	char gName[133];
	ads_getstring( Adesk::kFalse, "Enter Group Name:", gName );

	// Get color index.
	//
	while (iIndex < 0) {
		ads_getint("Enter color index:", &iIndex);
	}

	// Determine how to test.
	//
	char mode[133];
	ads_getstring(Adesk::kFalse, "Test UInt16 or AcCmColor [U/A]: ", mode);
	Adesk::Boolean uint = (mode[0] == 'U' || mode[0] == 'u');

	// Open group dictionary for read.
	//
	Acad::ErrorStatus status = acdbCurDwg()->groupTable( pGrpDict,
							AcDb::kForRead );

	// Update the color of all the entities from the group.
	//
	if ( status == Acad::eOk ) {
		AcDbGroup* pGrp;
		status = pGrpDict->getAt(gName, AcDb::kForWrite,
									*((AcDbObject**)&pGrp) );
		if (status == Acad::eOk) {
			if (uint == Adesk::kTrue) {
				status = pGrp->setColorIndex(iIndex);
			}
			else {
				AcCmColor color;
				color.setColorIndex( iIndex );
				status = pGrp->setColor( color );
			}

			if (status != Acad::eOk)
				ads_printf("\nUnable to set color, stat = %d\n", status);

			pGrp->close();
		}
		else {
			ads_printf("\nUnable to get %s, stat = %d\n", gName, status);
		}
	}
	else {
		ads_printf("\nUnable to open group dictionary, stat = %d\n", status);
	}
	pGrpDict->close();
}


// Set the layer for each entity in the group.
//
void setGroupLayer()
{
	AcDbDictionary* pGrpDict;

	// Get group from user.
	char gName[133];
	ads_getstring( Adesk::kFalse, "Enter Group Name:", gName );

	// Determine how to test.
	//
	char mode[133];
	ads_getstring(Adesk::kFalse, "Test by layer name or layer record Object Id [N/O]: ", mode);
	Adesk::Boolean use_name = (mode[0] == 'N' || mode[0] == 'n');

	// Get the layer
	//
	char lname[133];
	ads_getstring(Adesk::kFalse, "Enter layer name: ", lname);

	// AutoCAD layer names are stored in uppercase.
	//
	int len = strlen(lname);
	for (int i=0; i<len; i++)
		lname[i] = toupper(lname[i]);

	// Open group dictionary for read.
	//
	Acad::ErrorStatus status = acdbCurDwg()->groupTable( pGrpDict,
							AcDb::kForRead );

	// Update the layer of all the entities from the group.
	//
	if ( status == Acad::eOk ) {
		AcDbGroup* pGrp;
		status = pGrpDict->getAt(gName, AcDb::kForWrite,
								*((AcDbObject**)&pGrp) );
		if (status == Acad::eOk)
		{
	if (use_name == Adesk::kTrue) {
			status = pGrp->setLayer(lname);

		if (status != Acad::eOk)
			ads_printf("\nUnable to set layer, stat = %d\n", status);
	}
	else
	{
		// Test setting layer by getting the layer table record
		// that corresponds to the layer name.
		//
			AcDbObjectId id;
		AcDbLayerTable* pLayerTable;
		status = acdbCurDwg()->layerTable( pLayerTable, AcDb::kForRead );

		if (status == Acad::eOk) {
			AcDbLayerTableIterator* pIter;
			status = pLayerTable->newIterator(pIter);

			if (status == Acad::eOk) {
  				AcDbLayerTableRecord* pLayerRecord;
			char* pLayerName = new char[32];
			Adesk::Boolean found = Adesk::kFalse;

				for (; !pIter->done(); pIter->step()) {
				status = pIter->getRecord( AcDb::kForRead,
								pLayerRecord );

				if (status == Acad::eOk) {
				status = pLayerRecord->name( (char*)pLayerName );

			if (status == Acad::eOk) {

				// If we find a match, set each group entity's layer to equal
				// the layer described by the layer record we found.
				//
				if (!strcmp( pLayerName, lname )) {
				found = Adesk::kTrue;
				status = pGrp->setLayer( pLayerRecord->objectId() );

				if (status != Acad::eOk)
				ads_printf("\nUnable to set layer, stat = %d\n",
					status);

				break;
				}
			}
			else {
				ads_printf("\nUnable to get %s layer name, stat = %d\n",
				pLayerName, status);
			}

			pLayerRecord->close();
		}
		else {
			ads_printf("\nUnable to get layer table record, stat = %d\n",
					status);
		}
			}

			if (!found)
			ads_printf("\nUnable to find layer table record.\n");

			delete pLayerName;
			delete pIter;
		}
		else {
			ads_printf("\nUnable to get iterator for layer table, stat = %d\n",
				status);
		}

		pLayerTable->close();
		}
		else {
			ads_printf("\nUnable to get layer table, stat = %d\n", status);
		}
	}

		pGrp->close();
		}
		else {
		ads_printf("\nUnable to get %s, stat = %d\n", gName, status);
		}
	}
	else {
		ads_printf("\nUnable to open group dictionary, stat = %d\n", status);
	}
	pGrpDict->close();
}


// Set the linetype for each entity in the group.
//
void setGroupLinetype()
{
	AcDbDictionary* pGrpDict;

	// Get group from user.
	char gName[133];
	ads_getstring( Adesk::kFalse, "Enter Group Name:", gName );

	// Determine how to test.
	//
	char mode[133];
	ads_getstring(Adesk::kFalse, "Test by linetype name or linetype record Object Id [N/O]: ", mode);
	Adesk::Boolean use_name = (mode[0] == 'N' || mode[0] == 'n');

	// Get the linetype name
	//
	char lname[133];
	ads_getstring(Adesk::kFalse, "Enter linetype name: ", lname);

	// AutoCAD layer names are stored in uppercase.
	//
	int len = strlen(lname);
	for (int i=0; i<len; i++)
		lname[i] = toupper(lname[i]);

	// Open group dictionary for read.
	//
	Acad::ErrorStatus status = acdbCurDwg()->groupTable( pGrpDict,
							AcDb::kForRead );

	// Update the linetype of all the entities from the group.
	//
	if ( status == Acad::eOk ) {
		AcDbGroup* pGrp;
		status = pGrpDict->getAt(gName, AcDb::kForWrite,
									*((AcDbObject**)&pGrp) );

		if (status == Acad::eOk) {
		if (use_name == Adesk::kTrue) {
			status = pGrp->setLinetype(lname);

		if (status != Acad::eOk)
			ads_printf("\nUnable to set linetype, stat = %d\n", status);
		}
		else
		{
		// Test setting linetype by getting the linetype table record
		// that corresponds to the linetype name.
		//
			AcDbObjectId id;
		AcDbLinetypeTable* pLinetypeTable;
		status = acdbCurDwg()->linetypeTable( pLinetypeTable, AcDb::kForRead );

		if (status == Acad::eOk) {
			AcDbLinetypeTableIterator* pIter;
			status = pLinetypeTable->newIterator(pIter);

			if (status == Acad::eOk) {
  				AcDbLinetypeTableRecord* pLinetypeRecord;
			char* pLinetypeName = new char[32];
			Adesk::Boolean found = Adesk::kFalse;

				for (; !pIter->done(); pIter->step()) {
				status = pIter->getRecord( AcDb::kForRead,
								pLinetypeRecord );

				if (status == Acad::eOk) {
				status = pLinetypeRecord->name( pLinetypeName );

			if (status == Acad::eOk) {

					// If we find a match, set each group entity's linetype
					// to equal the linetype described by the linetype record
				// we found.
					//
					if (!strcmp( pLinetypeName, lname )) {
				found = Adesk::kTrue;
				status = pGrp->setLinetype( pLinetypeRecord->objectId() );

				if (status != Acad::eOk)
				ads_printf("\nUnable to set linetype, stat = %d\n",
					status);

				break;
				}
			}
			else {
				ads_printf("\nUnable to get %s linetype name, stat = %d\n",
				pLinetypeName, status);
			}

			pLinetypeRecord->close();
		}
		else {
			ads_printf("\nUnable to get linetype table record, stat = %d\n",
					status);
		}
			}

			if (!found)
			ads_printf("\nUnable to find linetype table record.\n");

			delete pLinetypeName;
			delete pIter;
		}
		else {
			ads_printf("\nUnable to get iterator for linetype table, stat = %d\n",
				status);
		}

		pLinetypeTable->close();
		}
		else {
			ads_printf("\nUnable to get linetype table, stat = %d\n", status);
		}
	}

		pGrp->close();
		}
		else {
		ads_printf("\nUnable to get %s, stat = %d\n", gName, status);
		}
	}
	else {
		ads_printf("\nUnable to open group dictionary, stat = %d\n", status);
	}
	pGrpDict->close();
}


// Set the linetype scale for each entity in the group.
//
void setGroupLinetypeScale()
{
	AcDbDictionary* pGrpDict;

	// Get group from user.
	char gName[133];
	ads_getstring( Adesk::kFalse, "Enter Group Name:", gName );

	// Get the scale
	//
	ads_real scale;
	ads_getreal("Enter linetype scale: ", &scale);

	// Open group dictionary for read.
	//
	Acad::ErrorStatus status = acdbCurDwg()->groupTable( pGrpDict,
							AcDb::kForRead );

	// Update the linetype scale of all the entities from the group.
	//
	if ( status == Acad::eOk ) {
		AcDbGroup* pGrp;
		status = pGrpDict->getAt(gName, AcDb::kForWrite,
									*((AcDbObject**)&pGrp) );
		if (status == Acad::eOk) {
			status = pGrp->setLinetypeScale(scale);

		if (status != Acad::eOk)
		ads_printf("\nUnable to set linetype scale, stat = %d\n", status);

		pGrp->close();
		}
		else {
		ads_printf("\nUnable to get %s, stat = %d\n", gName, status);
		}
	}
	else {
		ads_printf("\nUnable to open group dictionary, stat = %d\n", status);
	}
	pGrpDict->close();
}


// Set the visibility for each entity in the group.
//
void setGroupVisibility()
{
	AcDbDictionary* pGrpDict;

	// Get group from user.
	char gName[133];
	ads_getstring( Adesk::kFalse, "Enter Group Name:", gName );

	// Get the visibility
	//
	char vis_str[133];
	ads_getstring( Adesk::kFalse, "Make group visible or invisible [V/I]: ",
			vis_str );

	AcDb::Visibility vis;
	if (vis_str[0] == 'V' || vis_str[0] == 'v')
		vis = AcDb::kVisible;
	else
		vis = AcDb::kInvisible;


	// Open group dictionary for read.
	//
	Acad::ErrorStatus status = acdbCurDwg()->groupTable( pGrpDict,
							AcDb::kForRead );

	// Update the visibility of all the entities from the group.
	//
	if ( status == Acad::eOk ) {
		AcDbGroup* pGrp;
		status = pGrpDict->getAt(gName, AcDb::kForWrite,
									*((AcDbObject**)&pGrp) );
		if (status == Acad::eOk) {
			status = pGrp->setVisibility(vis);

		if (status != Acad::eOk)
		ads_printf("\nUnable to set visibility, stat = %d\n", status);

		pGrp->close();
		}
		else {
		ads_printf("\nUnable to get %s, stat = %d\n", gName, status);
		}
	}
	else {
		ads_printf("\nUnable to open group dictionary, stat = %d\n", status);
	}
	pGrpDict->close();
}


// Set the highlighting for each entity in the group.
//
void setGroupHighlight()
{
	AcDbDictionary* pGrpDict;

	// Get group from user.
	char gName[133];
	ads_getstring( Adesk::kFalse, "Enter Group Name:", gName );

	// Get highlight
	//
	char hstr[133];
	ads_getstring( Adesk::kFalse, "Highlight or unhighlight group [H/U]: ", hstr);
	Adesk::Boolean highlight = (hstr[0] == 'H' || hstr[0] == 'h');

	// Open group dictionary for read.
	//
	Acad::ErrorStatus status = acdbCurDwg()->groupTable( pGrpDict,
							AcDb::kForRead );

	// Update the highlighting of all the entities from the group.
	//
	if ( status == Acad::eOk ) {
		AcDbGroup* pGrp;
		status = pGrpDict->getAt(gName, AcDb::kForWrite,
									*((AcDbObject**)&pGrp) );
		if (status == Acad::eOk) {
			status = pGrp->setHighlight(highlight);

		if (status != Acad::eOk)
		ads_printf("\nUnable to set highlight, stat = %d\n", status);

		pGrp->close();
		}
		else {
		ads_printf("\nUnable to get %s, stat = %d\n", gName, status);
		}
	}
	else {
		ads_printf("\nUnable to open group dictionary, stat = %d\n", status);
	}
	pGrpDict->close();
}

