#ifndef AD_DBXUTIL_H
#define AD_DBXUTIL_H 1
//
// $Id: dbxutil.h,v 1.7 1995/09/30 15:29:58 jamesr Exp $
//
// (C) Copyright 1993-1995 by Autodesk, Inc.
//
// The information contained herein is confidential, proprietary
// to Autodesk,  Inc.,	and considered a trade secret as defined
// in section 499C of the penal code of the State of California.
// Use of  this information  by  anyone  other	than  authorized
// employees of Autodesk, Inc.	is granted  only under a written
// non-disclosure agreement,  expressly  prescribing  the  scope
// and manner of such use.
//
// DESCRIPTION: Header for homeless utilities exported to the API.
//
// The following functions are used to handle string values returned
// to from (or passed into) the acdb API.  newString() is analogous
// to strdup() except that it uses new instead of malloc() and it
// returns an error status.  updString() performs the same job as
// new string except that it first frees any string already pointed
// to by the output argument.  delString() uses delete to free up
// a string if the input pointer is non NULL and then sets the
// pointer to NULL.
//
// Yes, of course a decent string class would be better.

#include "acdb.h"

extern Acad::ErrorStatus newBuffer(char *&pOutput, int size);
extern Acad::ErrorStatus newString(const char* pInput, char*& pOutput);
extern Acad::ErrorStatus updString(const char* pInput, char*& pOutput);
extern void delString(char*& pString);
#define delBuffer(x) delString(x)
extern Acad::ErrorStatus newAcDbBuffer(char *&pOutput, int size);
extern Acad::ErrorStatus newAcDbString(const char* pInput, char*& pOutput);

#endif
