#ifndef AC_GEEXTC2D_H
#define AC_GEEXTC2D_H
//
// $Id: geextc2d.h,v 1.7 1995/10/26 16:34:05 neb Exp $
//
// (C) Copyright 1993-1995 by Autodesk, Inc.
//
// The information contained herein is confidential, proprietary  to
// Autodesk,  Inc., and considered a trade secret as defined in sec-
// tion 499C of the penal code of the State of California.   Use  of
// this information by anyone other than authorized employees of Au-
// todesk, Inc. is  granted  only  under  a  written  non-disclosure
// agreement,  expressly  prescribing  the  scope and manner of such
// use.
//
// DESCRIPTION:
//
// This file contains the class AcGeExternalCurve2d - A 
// representation for a curve that has its definition external to 
// gelib.

#include "gecurv2d.h"
#include "gearc2d.h"
#include "gevec2d.h"
#include "gepnt2d.h"

class AcGeNurbCurve2d;
class AcGeExternalCurve2d;
class AcGeExternalCurve2d;

class AcGeExternalCurve2d : public AcGeCurve2d
{
public:
    AcGeExternalCurve2d();
    AcGeExternalCurve2d(const AcGeExternalCurve2d&);
    AcGeExternalCurve2d(void* curve2dDef, AcGe::ExternalEntityKind,
                            Adesk::Boolean makeCopy = Adesk::kTrue);
              
    Adesk::Boolean isNurbCurve      () const;
    Adesk::Boolean isNurbCurve      (AcGeNurbCurve2d&) const;
    Adesk::Boolean isDefined        () const;

    void           getExternalCurve (void*&) const;

    // Type of the external curve.
    //
    AcGe::ExternalEntityKind     externalCurveKind () const;

    // Reset surface
    //
    AcGeExternalCurve2d& set      (void* curveDef, AcGe::ExternalEntityKind,
                                    Adesk::Boolean makeCopy = Adesk::kTrue);
     
    // Assignment operator
    //
    AcGeExternalCurve2d& operator = (const AcGeExternalCurve2d&);

    // Ownership of curve
    //
    Adesk::Boolean       isOwnerOfCurve   () const;
    AcGeExternalCurve2d& setToOwnCurve    ();

protected:  
    friend class AcGeImpExternalCurve2d;
    
    // Construct object from its corresponding implementation object
    //
    AcGeExternalCurve2d (AcGeImpExternalCurve2d&, int);
    AcGeExternalCurve2d (AcGeImpExternalCurve2d*);

};

#endif
