#ifndef AC_GEEXTSF_H
#define AC_GEEXTSF_H
//
// $Id: geextsf.h,v 1.8 1995/10/26 16:34:20 neb Exp $
//
// (C) Copyright 1993-1995 by Autodesk, Inc. 
//
// The information contained herein is confidential, proprietary  to 
// Autodesk,  Inc., and considered a trade secret as defined in sec- 
// tion 499C of the penal code of the State of California.   Use  of 
// this information by anyone other than authorized employees of Au- 
// todesk, Inc. is  granted  only  under  a  written  non-disclosure 
// agreement,  expressly  prescribing  the  scope and manner of such 
// use.
//
// Description:
//
// This file implements the class AcGeExternalSurface, a
// representation for a surface that has its definition external 
// to gelib. 
// 
     
#include "gegbl.h"
#include "gesurf.h"
     
class AcGePlane;
class AcGeCylinder;
class AcGeCone;
class AcGeSphere;
class AcGeTorus;
class AcGeNurbSurface;
     
     
class surface;
     
class AcGeExternalSurface : public AcGeSurface 
{
public:
   AcGeExternalSurface();
   AcGeExternalSurface(void* surfaceDef, AcGe::ExternalEntityKind,
                       Adesk::Boolean makeCopy = Adesk::kTrue);
   AcGeExternalSurface(const AcGeExternalSurface&);
     
   // Defining surface.
   //
   void  getExternalSurface(void*&) const;
   
   // Type of the external surface.
   //
   AcGe::ExternalEntityKind  externalSurfaceKind() const;
   
   Adesk::Boolean    isPlane        () const; 
   Adesk::Boolean    isSphere       () const;
   Adesk::Boolean    isCylinder     () const;   
   Adesk::Boolean    isCone         () const; 
   Adesk::Boolean    isTorus        () const; 
   Adesk::Boolean    isNurbSurface  () const;
  
   Adesk::Boolean    isDefined      () const;
     
   // Conversion to gelib entity
   //
   Adesk::Boolean    isNativeSurface(AcGeSurface*&) const;

   // Assignment operator.
   //
   AcGeExternalSurface& operator = (const AcGeExternalSurface&);
     
   // Reset surface
   //
   AcGeExternalSurface& set    (void* surfaceDef,
                                AcGe::ExternalEntityKind,
                                Adesk::Boolean makeCopy = Adesk::kTrue);
     
   // Ownership of surface.
   //
   Adesk::Boolean       isOwnerOfSurface    () const; 
   AcGeExternalSurface& setToOwnSurface     ();
     
private:
    friend class AcGeImpExternalSurface;
    AcGeExternalSurface (AcGeImpExternalSurface&, int);
    AcGeExternalSurface (AcGeImpExternalSurface*);
};
     
#endif
