#ifndef AC_GEGBLABB_H
#define AC_GEGBLABB_H
//
// $Id: gegblabb.h,v 1.10 1995/10/26 16:34:36 neb Exp $
//
// (C) Copyright 1993-1995 by Autodesk, Inc.
//
// The information contained herein is confidential, proprietary  to
// Autodesk,  Inc., and considered a trade secret as defined in sec-
// tion 499C of the penal code of the State of California.   Use  of
// this information by anyone other than authorized employees of Au-
// todesk, Inc. is  granted  only  under  a  written  non-disclosure
// agreement,  expressly  prescribing  the  scope and manner of such
// use.
//
// DESCRIPTION:
//
// Using the fully qualified names from the `AcGe' struct can be
// cumbersome.  If there are no global name conflicts use the
// following synonyms for convenience.
//
// Note:  All interface descriptions must use fully qualified names.
//        That is, header files MUST NOT include this file and MUST
//        NOT use these abbreviations.
//
// Note:  If any of the following abbreviations cause conflicts and
//        this file cannot be included, then the acceptable abbreviations
//        (those that do not cause conflicts) will have to be manually
//        introduced, or another abbreviation header file will have to
//        be created containing only the acceptable abbreviations.
//
// Note:  When this file is included in a source file, it MUST BE
//        included AFTER all other include files (except possibly
//        other abbreviation include files).
//        For example:
//            #include "foo.h"
//            #include "bar.h"
//            #include "gegblabb.h" // <- Must be last!

#include "gegbl.h"

const int eGood = AcGe::eGood;
const int eBad = AcGe::eBad;

typedef AcGe::EntityId EntityId;

const AcGe::EntityId kEntity2d = AcGe::kEntity2d;
const AcGe::EntityId kEntity3d = AcGe::kEntity3d;
const AcGe::EntityId kPointEnt2d = AcGe::kPointEnt2d;
const AcGe::EntityId kPointEnt3d = AcGe::kPointEnt3d;
const AcGe::EntityId kPosition2d = AcGe::kPosition2d;
const AcGe::EntityId kPosition3d = AcGe::kPosition3d;
const AcGe::EntityId kPointOnCurve2d = AcGe::kPointOnCurve2d;
const AcGe::EntityId kPointOnCurve3d = AcGe::kPointOnCurve3d;
const AcGe::EntityId kBoundedPlane = AcGe::kBoundedPlane;
const AcGe::EntityId kCircArc2d = AcGe::kCircArc2d;
const AcGe::EntityId kCircArc3d = AcGe::kCircArc3d;
const AcGe::EntityId kConic2d = AcGe::kConic2d;
const AcGe::EntityId kConic3d = AcGe::kConic3d;
const AcGe::EntityId kCurve2d = AcGe::kCurve2d;
const AcGe::EntityId kCurve3d = AcGe::kCurve3d;
const AcGe::EntityId kEllipArc2d = AcGe::kEllipArc2d;
const AcGe::EntityId kEllipArc3d = AcGe::kEllipArc3d;
const AcGe::EntityId kLine2d = AcGe::kLine2d;
const AcGe::EntityId kLine3d = AcGe::kLine3d;
const AcGe::EntityId kLinearEnt2d = AcGe::kLinearEnt2d;
const AcGe::EntityId kLinearEnt3d = AcGe::kLinearEnt3d;
const AcGe::EntityId kLineSeg2d = AcGe::kLineSeg2d;
const AcGe::EntityId kLineSeg3d = AcGe::kLineSeg3d;
const AcGe::EntityId kPlanarEnt = AcGe::kPlanarEnt;
const AcGe::EntityId kExternalCurve3d = AcGe::kExternalCurve3d;
const AcGe::EntityId kExternalCurve2d = AcGe::kExternalCurve2d;
const AcGe::EntityId kPlane = AcGe::kPlane;
const AcGe::EntityId kRay2d = AcGe::kRay2d;
const AcGe::EntityId kRay3d = AcGe::kRay3d;
const AcGe::EntityId kSurface = AcGe::kSurface;
const AcGe::EntityId kSphere = AcGe::kSphere;
const AcGe::EntityId kCone = AcGe::kCone;
const AcGe::EntityId kTorus = AcGe::kTorus;
const AcGe::EntityId kCylinder = AcGe::kCylinder;
const AcGe::EntityId kSplineEnt2d = AcGe::kSplineEnt2d;
const AcGe::EntityId kSurfaceCurve2dTo3d = AcGe::kSurfaceCurve2dTo3d;
const AcGe::EntityId kSurfaceCurve3dTo2d = AcGe::kSurfaceCurve3dTo2d;

const AcGe::EntityId kPolyline2d = AcGe::kPolyline2d;
const AcGe::EntityId kAugPolyline2d = AcGe::kAugPolyline2d;
const AcGe::EntityId kNurbCurve2d = AcGe::kNurbCurve2d;
const AcGe::EntityId kDSpline2d = AcGe::kDSpline2d;
const AcGe::EntityId kCubicSplineCurve2d = AcGe::kCubicSplineCurve2d;
const AcGe::EntityId kSplineEnt3d = AcGe::kSplineEnt3d;
const AcGe::EntityId kPolyline3d = AcGe::kPolyline3d;
const AcGe::EntityId kAugPolyline3d = AcGe::kAugPolyline3d;
const AcGe::EntityId kNurbCurve3d = AcGe::kNurbCurve3d;
const AcGe::EntityId kDSpline3d = AcGe::kDSpline3d;
const AcGe::EntityId kCubicSplineCurve3d = AcGe::kCubicSplineCurve3d;
const AcGe::EntityId kTrimmedCrv2d = AcGe::kTrimmedCrv2d;
const AcGe::EntityId kCompositeCrv2d = AcGe::kCompositeCrv2d;
const AcGe::EntityId kEnvelope2d = AcGe::kEnvelope2d;

const AcGe::EntityId kExternalSurface = AcGe::kExternalSurface;
const AcGe::EntityId kNurbSurface = AcGe::kNurbSurface;
const AcGe::EntityId kOffsetSurface = AcGe::kOffsetSurface;
const AcGe::EntityId kTrimmedSurface = AcGe::kTrimmedSurface;
const AcGe::EntityId kCurveBoundedSurface = AcGe::kCurveBoundedSurface;
const AcGe::EntityId kPointOnSurface = AcGe::kPointOnSurface;
const AcGe::EntityId kExternalBoundedSurface = AcGe::kExternalBoundedSurface;


typedef AcGe::ExternalEntityKind ExternalEntityKind;

const AcGe::ExternalEntityKind kAcisEntity = AcGe::kAcisEntity;
const AcGe::ExternalEntityKind kExternalEntityUndefined
                                = AcGe::kExternalEntityUndefined;

typedef AcGe::NurbSurfaceProperties NurbSurfaceProperties;

const AcGe::NurbSurfaceProperties kOpen = AcGe::kOpen;
const AcGe::NurbSurfaceProperties kClosed = AcGe::kClosed;
const AcGe::NurbSurfaceProperties kPeriodic = AcGe::kPeriodic;
const AcGe::NurbSurfaceProperties kRational = AcGe::kRational;
const AcGe::NurbSurfaceProperties kNoPoles= AcGe::kNoPoles;
const AcGe::NurbSurfaceProperties kPoleAtMin = AcGe::kPoleAtMin;
const AcGe::NurbSurfaceProperties kPoleAtMax = AcGe::kPoleAtMax;
const AcGe::NurbSurfaceProperties kPoleAtBoth = AcGe::kPoleAtBoth;

typedef AcGe::PointContainment PointContainment;

const AcGe::PointContainment kInside = AcGe::kInside;
const AcGe::PointContainment kOutside = AcGe::kOutside;
const AcGe::PointContainment kOnBoundary = AcGe::kOnBoundary;

#endif
