#ifndef AC_GELINE3D_H
#define AC_GELINE3D_H
//
// $Id: geline3d.h,v 1.3 1995/12/20 15:17:14 neb Exp $
//
// (C) Copyright 1993-1995 by Autodesk, Inc.
//
// The information contained herein is confidential, proprietary  to
// Autodesk,  Inc., and considered a trade secret as defined in sec-
// tion 499C of the penal code of the State of California.   Use  of
// this information by anyone other than authorized employees of Au-
// todesk, Inc. is  granted  only  under  a  written  non-disclosure
// agreement,  expressly  prescribing  the  scope and manner of such
// use.
//
// DESCRIPTION:
//
// This file contains the class AcGeLinearEnt3d - A mathematical entity
// used to represent a line in 3-space.

#include "gelent3d.h"

class AcGeLine2d;

class AcGeLine3d : public AcGeLinearEnt3d
{
public:
    AcGeLine3d();
    AcGeLine3d(const AcGeLine3d&);
    AcGeLine3d(const AcGePoint3d&, const AcGeVector3d&);
    AcGeLine3d(const AcGePoint3d&, const AcGePoint3d&);

    // The x-axis, y-axis, and z-axis lines.
    //
    static const   AcGeLine3d  kXAxis;
    static const   AcGeLine3d  kYAxis;
    static const   AcGeLine3d  kZAxis;

    // Set methods.
    //
    AcGeLine3d&    set         (const AcGePoint3d&, const AcGeVector3d&);
    AcGeLine3d&    set         (const AcGePoint3d&, const AcGePoint3d&);

    // Assignment operator.
    //
    AcGeLine3d&    operator =  (const AcGeLine3d&);

protected:

    friend class AcGeImpLine3d;

    // Construct object from its corresponding implementation object.
    AcGeLine3d (AcGeImpLine3d&, int);
    AcGeLine3d (AcGeImpLine3d*);
};

#endif
