#ifndef AC_GELNSG3D_H
#define AC_GELNSG3D_H
//
// $Id: gelnsg3d.h,v 1.4 1995/12/20 15:17:20 neb Exp $
//
// (C) Copyright 1993-1995 by Autodesk, Inc.
//
// The information contained herein is confidential, proprietary  to
// Autodesk,  Inc., and considered a trade secret as defined in sec-
// tion 499C of the penal code of the State of California.   Use  of
// this information by anyone other than authorized employees of Au-
// todesk, Inc. is  granted  only  under  a  written  non-disclosure
// agreement,  expressly  prescribing  the  scope and manner of such
// use.
//
// DESCRIPTION:
//
// This file contains the class AcGeLineSeg3d - A mathematical entity
// used to represent linear segment in 3d space.

#include "geline3d.h"
#include "geplane.h"

class AcGeLineSeg2d;

class AcGeLineSeg3d : public AcGeLinearEnt3d
{
public:
    AcGeLineSeg3d();
    AcGeLineSeg3d(const AcGeLineSeg3d&);
    AcGeLineSeg3d(const AcGePoint3d&, const AcGeVector3d&);
    AcGeLineSeg3d(const AcGePoint3d&, const AcGePoint3d&);

    // Bisector.
    //
    void           getBisector  (AcGePlane&) const;

    // Barycentric combination of end points.
    //
    AcGePoint3d    baryComb     (double blendCoeff) const;

    // Definition of linear segment
    //
    AcGePoint3d    startPoint   () const;
    AcGePoint3d    midPoint     () const;
    AcGePoint3d    endPoint     () const;
    double         length       () const;
    double         length       (double fromParam, double toParam,
                                 double = AcGeContext::gTol.equalPoint()) const;
    // Set methods.
    //
    AcGeLineSeg3d& set          (const AcGePoint3d&, const AcGeVector3d&);
    AcGeLineSeg3d& set          (const AcGePoint3d&, const AcGePoint3d&);

    // Assignment operator.
    //
    AcGeLineSeg3d& operator =   (const AcGeLineSeg3d&);

protected:

    friend class AcGeImpLineSeg3d;

    // Construct object from its corresponding implementation object.
    AcGeLineSeg3d (AcGeImpLineSeg3d&, int);
    AcGeLineSeg3d (AcGeImpLineSeg3d*);
};

#endif
