#ifndef AC_GEOFFSF_H
#define AC_GEOFFSF_H
//
// $Id: geoffsf.h,v 1.4 1995/10/26 16:35:37 neb Exp $
//
// (C) Copyright 1993-1995 by Autodesk, Inc. 
//
// The information contained herein is confidential, proprietary  to 
// Autodesk,  Inc., and considered a trade secret as defined in sec- 
// tion 499C of the penal code of the State of California.   Use  of 
// this information by anyone other than authorized employees of Au- 
// todesk, Inc. is  granted  only  under  a  written  non-disclosure 
// agreement,  expressly  prescribing  the  scope and manner of such 
// use.
//
// Description:
//
// This file contains the class AcGeOffsetSurface, a 
// representation for an offset surface 
// 
     
#include "gegbl.h"
#include "gepnt3d.h"
#include "gesurf.h"
     
class AcGePlane;
class AcGeBoundedPlane;
class AcGeCylinder;
class AcGeCone;
class AcGeSphere;
class AcGeTorus;
     
class AcGeOffsetSurface : public AcGeSurface 
{
public:
    AcGeOffsetSurface();
    AcGeOffsetSurface(AcGeSurface* constructionSurface, 
                      double offsetDist,
                      Adesk::Boolean makeCopy = Adesk::kTrue);
    AcGeOffsetSurface(const AcGeOffsetSurface&);
     
    // Test whether this offset surface can be converted to a simple surface 
    //
    Adesk::Boolean    isPlane        () const; 
    Adesk::Boolean    isBoundedPlane () const; 
    Adesk::Boolean    isSphere       () const; 
    Adesk::Boolean    isCylinder     () const; 
    Adesk::Boolean    isCone         () const; 
    Adesk::Boolean    isTorus        () const;
     
    // Convert this offset surface to a simple surface 
    //
	Adesk::Boolean	  getSurface(AcGeSurface*&) const;

    // Get a copy of the construction surface.
    //
    void 			  getConstructionSurface (AcGeSurface*&) const; 

    double            offsetDist     () const;
     
    // Reset surface
    //
    AcGeOffsetSurface& set        (AcGeSurface*, double offsetDist,
                                    Adesk::Boolean makeCopy = Adesk::kTrue);
     
    // Assignment operator.
    //
    AcGeOffsetSurface& operator =  (const AcGeOffsetSurface&);
     
private:
     
    friend class AcGeImpOffsetSurface;
     
    // Construct object from its corresponding implementation object. 
    AcGeOffsetSurface (AcGeImpOffsetSurface&, int);
    AcGeOffsetSurface (AcGeImpOffsetSurface*);
};
     
#endif
