#ifndef AC_GEPENT3D_H
#define AC_GEPENT3D_H
//
// $Id: gepent3d.h,v 1.1 1995/07/28 16:53:44 tomba Exp $
//
// (C) Copyright 1993-1995 by Autodesk, Inc.
//
// The information contained herein is confidential, proprietary  to
// Autodesk,  Inc., and considered a trade secret as defined in sec-
// tion 499C of the penal code of the State of California.   Use  of
// this information by anyone other than authorized employees of Au-
// todesk, Inc. is  granted  only  under  a  written  non-disclosure
// agreement,  expressly  prescribing  the  scope and manner of such
// use.
//
// DESCRIPTION:
//
// This file contains the class AcGePointEnt3d - An abstract base
// class to represent point entities.

#include "adesk.h"
#include "geent3d.h"

class AcGePointEnt3d : public AcGeEntity3d
{
public:

    // Return point coordinates.
    //
    AcGePoint3d     point3d     () const;

    // Conversion operator to convert to AcGePoint3d.
    //
    operator        AcGePoint3d () const;
    
    // Assignment operator.
    //
    AcGePointEnt3d& operator =  (const AcGePointEnt3d&);

protected:

    friend class AcGeImpPointEnt3d;

    // Private constructors so that no object of this class can be instantiated.
    AcGePointEnt3d ();
    AcGePointEnt3d (const AcGePointEnt3d&);

    // Construct object from its corresponding implementation object.
    AcGePointEnt3d (AcGeImpPointEnt3d&, int);
    AcGePointEnt3d (AcGeImpPointEnt3d*);
};

#endif
