#ifndef AC_GEPLIN2D_H
#define AC_GEPLIN2D_H
//
// $Id: geplin2d.h,v 1.2 1995/10/26 16:36:00 neb Exp $
//
// (C) Copyright 1993-1995 by Autodesk, Inc.
//
// The information contained herein is confidential, proprietary  to
// Autodesk,  Inc., and considered a trade secret as defined in sec-
// tion 499C of the penal code of the State of California.   Use  of
// this information by anyone other than authorized employees of Au-
// todesk, Inc. is  granted  only  under  a  written  non-disclosure
// agreement,  expressly  prescribing  the  scope and manner of such
// use.
//
// DESCRIPTION:
//
// This file contains the class AcGePolyline2d - A mathematical entity
// used to represent a different types of spline curves in 3-space.

#include "gecurv2d.h"
#include "gekvec.h"
#include "gept2dar.h"
#include "gevec2d.h"
#include "gepnt2d.h"
#include "gesent2d.h"


class AcGePolyline2d : public AcGeSplineEnt2d
{
public:

    AcGePolyline2d();
    AcGePolyline2d( const AcGePolyline2d& src );
    AcGePolyline2d( const AcGePoint2dArray& );

    // Approximate curve with polyline
    //
    AcGePolyline2d( const AcGeCurve2d& crv, double apprEps );

    // Interpolation data
    //
    int              numFitPoints () const;
    AcGePoint2d      fitPointAt   (int idx) const;
    AcGeSplineEnt2d& setFitPointAt(int idx, const AcGePoint2d&);

    // Assignment operator.
    //
    AcGePolyline2d& operator =     (const AcGePolyline2d&);

protected:

    friend class AcGeImpPolyline2d;

    // Construct object from its corresponding implementation object.
    AcGePolyline2d (AcGeImpPolyline2d&, int);
    AcGePolyline2d (AcGeImpPolyline2d*);

};

#endif
