#ifndef AC_GEPOS3D_H
#define AC_GEPOS3D_H
//
// $Id: gepos3d.h,v 1.2 1995/09/06 12:50:29 tomba Exp $
//
// (C) Copyright 1993-1995 by Autodesk, Inc.
//
// The information contained herein is confidential, proprietary  to
// Autodesk,  Inc., and considered a trade secret as defined in sec-
// tion 499C of the penal code of the State of California.   Use  of
// this information by anyone other than authorized employees of Au-
// todesk, Inc. is  granted  only  under  a  written  non-disclosure
// agreement,  expressly  prescribing  the  scope and manner of such
// use.
//
// DESCRIPTION:
//
// This file contains the class AcGePosition3d - A 3d point entity.

#include "adesk.h"
#include "gepent3d.h"
#include "gepnt3d.h"

class AcGePosition3d : public AcGePointEnt3d
{
public:
    AcGePosition3d ();
    AcGePosition3d (const AcGePoint3d&);
    AcGePosition3d (double x, double y, double z);
    AcGePosition3d (const AcGePosition3d&);

    // Set point coordinates.
    //
    AcGePosition3d&  set        (const AcGePoint3d&);
    AcGePosition3d&  set        (double x, double y, double z );
    
    // Assignment operator.
    //
    AcGePosition3d& operator =  (const AcGePosition3d&);

protected:

    friend class AcGeImpPosition3d;

    // Construct object from its corresponding implementation object.
    AcGePosition3d (AcGeImpPosition3d&, int);
    AcGePosition3d (AcGeImpPosition3d*);
};

#endif
