#ifndef AC_GERAY2D_H
#define AC_GERAY2D_H
//
// $Id: geray2d.h,v 1.1 1995/07/28 16:54:04 tomba Exp $
//
// (C) Copyright 1993,1995 by Autodesk, Inc.
//
// The information contained herein is confidential, proprietary  to
// Autodesk,  Inc., and considered a trade secret as defined in sec-
// tion 499C of the penal code of the State of California.   Use  of
// this information by anyone other than authorized employees of Au-
// todesk, Inc. is  granted  only  under  a  written  non-disclosure
// agreement,  expressly  prescribing  the  scope and manner of such
// use.
//
// DESCRIPTION:
//
// This file contains the class AcGeRay2d - A mathematical entity
// used to represent a ray (half line) in 2-space.

#include "gelent2d.h"

class AcGeRay2d : public AcGeLinearEnt2d
{
public:
    AcGeRay2d();
    AcGeRay2d(const AcGeRay2d&);
    AcGeRay2d(const AcGePoint2d&, const AcGeVector2d&);
    AcGeRay2d(const AcGePoint2d&, const AcGePoint2d&);

    // Set methods.
    //
    AcGeRay2d&     set         (const AcGePoint2d&, const AcGeVector2d&);
    AcGeRay2d&     set         (const AcGePoint2d&, const AcGePoint2d&);

    // Assignment operator.
    //
    AcGeRay2d&     operator =  (const AcGeRay2d&);

protected:

    friend class AcGeImpRay2d;

    // Construct object from its corresponding implementation object.
    AcGeRay2d (AcGeImpRay2d&, int);
    AcGeRay2d (AcGeImpRay2d*);
};

#endif
