#ifndef AC_GERAY3D_H
#define AC_GERAY3D_H
//
// $Id: geray3d.h,v 1.3 1995/12/20 15:17:53 neb Exp $
//
// (C) Copyright 1993,1995 by Autodesk, Inc.
//
// The information contained herein is confidential, proprietary  to
// Autodesk,  Inc., and considered a trade secret as defined in sec-
// tion 499C of the penal code of the State of California.   Use  of
// this information by anyone other than authorized employees of Au-
// todesk, Inc. is  granted  only  under  a  written  non-disclosure
// agreement,  expressly  prescribing  the  scope and manner of such
// use.
//
// DESCRIPTION:
//
// This file contains the class AcGeRay3d - A mathematical entity
// used to represent a ray (half line) in 3-space.

#include "gelent3d.h"

class AcGeRay2d;

class AcGeRay3d : public AcGeLinearEnt3d
{
public:
    AcGeRay3d();
    AcGeRay3d(const AcGeRay3d&);
    AcGeRay3d(const AcGePoint3d&, const AcGeVector3d&);
    AcGeRay3d(const AcGePoint3d&, const AcGePoint3d&);

    // Set methods.
    //
    AcGeRay3d&     set         (const AcGePoint3d&, const AcGeVector3d&);
    AcGeRay3d&     set         (const AcGePoint3d&, const AcGePoint3d&);

    // Assignment operator.
    //
    AcGeRay3d&     operator =  (const AcGeRay3d&);

protected:

    friend class AcGeImpRay3d;

    // Construct object from its corresponding implementation object.
    AcGeRay3d (AcGeImpRay3d&, int);
    AcGeRay3d (AcGeImpRay3d*);
};

#endif
