#ifndef AC_GESPNT2d_H
#define AC_GESPNT2d_H
//
// $Id: gesent2d.h,v 1.3 1995/10/26 16:36:15 neb Exp $
//
// (C) Copyright 1993-1995 by Autodesk, Inc.
//
// The information contained herein is confidential, proprietary  to
// Autodesk,  Inc., and considered a trade secret as defined in sec-
// tion 499C of the penal code of the State of California.   Use  of
// this information by anyone other than authorized employees of Au-
// todesk, Inc. is  granted  only  under  a  written  non-disclosure
// agreement,  expressly  prescribing  the  scope and manner of such
// use.
//
// DESCRIPTION:
//
// This file contains the class AcGeSplineEnt2d - A mathematical entity
// used to represent a different types of spline curves in 3-space.

#include "gecurv2d.h"
#include "gekvec.h"
#include "gept2dar.h"
#include "gevec2d.h"
#include "gepnt2d.h"

class AcGeKnotVector;
class AcGePoint2dArray;

class AcGeSplineEnt2d : public AcGeCurve2d
{
public:

    // Definition of spline
    //
    Adesk::Boolean    isRational            () const;
    int               degree                () const;
    int               order                 () const;
    int               numKnots              () const;
    const
    AcGeKnotVector&   knots                 () const;
    int               numControlPoints      () const;
    int               continuityAtKnot      ( int, const AcGeTol& = 
                                              AcGeContext::gTol ) const;

    double            startParam            () const;
    double            endParam              () const;
    AcGePoint2d       startPoint            () const;
    AcGePoint2d       endPoint              () const;

    // Interpolation data
    //
    Adesk::Boolean    hasFitData            () const;

    // Editting
    //                                   
    double            knotAt                (int idx) const;
    AcGeSplineEnt2d&  setKnotAt             (int idx, double val);

    AcGePoint2d       controlPointAt        (int idx) const;
    AcGeSplineEnt2d&  setControlPointAt     (int idx, const AcGePoint2d& pnt);

    // Assignment operator.
    //
    AcGeSplineEnt2d&  operator =            (const AcGeSplineEnt2d&);

protected:

    friend class AcGeImpSplineEnt2d;

    // Private constructors so that no object of this class can be instantiated.
    AcGeSplineEnt2d ();
    AcGeSplineEnt2d (const AcGeSplineEnt2d&);

    // Construct object from its corresponding implementation object.
    AcGeSplineEnt2d (AcGeImpSplineEnt2d&, int);
    AcGeSplineEnt2d (AcGeImpSplineEnt2d*);
};

#endif

